<?php

/**
 * XForum2pnForum v1.0 (c) Fernando Jordan Silva (el_cuervo)
 *
 * cuervo@dev-postnuke.com
 *
 * You are using this on your own risk!!!
 * You are using this on your own risk!!!
 * You are using this on your own risk!!!
 *
 * Be sure to backup your database before running this script.
 * Be sure to backup your database before running this script.
 * Be sure to backup your database before running this script.
 *
 */

include "includes/pnAPI.php";

global $dbconn, $pntable, $prefix;
// Tablas de XForum
global $xfprefix,$xf_table_forums,$xf_table_members,$xf_table_posts,$xf_table_threads;

pnInit();

if (!pnSecAuthAction(0, 'pnForum::', "::", ACCESS_ADMIN)) {
    pnRedirect("index.php");
}
// TABLAS DE XFORUM
$xfprefix = "nuke_XForum_";
$xf_table_forums = $xfprefix . "forums";
$xf_table_members = $xfprefix . "members";
$xf_table_posts = $xfprefix . "posts";
$xf_table_threads = $xfprefix . "threads";

pnModDBInfoLoad('pnForum');
$dbconn =& pnDBGetConn(true);
$pntable = pnDBGetTables();
$prefix = pnConfigGetVar('prefix');

// Tiempo de trabajo del script
$time_start = microtime_float();
set_time_limit(0);

if(!pnModAPILoad('pnForum', 'user')) {
    die('unable to load pnForum userapi!!');
}

$id = pnVarCleanFromInput('id');
flush();
menu($id);

/*
convert_ranks(); 			// No se hace
convert_topics_watch();		// Quiza en el futuro
*/

switch( $id ) {
	case 1: {
        truncate_destination_tables();
		break;
	}
	case 2: {
		convert_categories();
		break;
	}
	case 3: {
		convert_forums();
		break;
	}
	case 4: {
		convert_topics();
		break;
	}
	case 5: {
		convert_posts();
		break;
	}
	case 6: {
		convert_mods();
		break;
	}
	case 7: {
		optimize();
		break;
	}
	case 8: {
		truncate_destination_tables();
		convert_categories();
		convert_forums();
		convert_topics();
		convert_posts();
		convert_mods();
		optimize();
		break;
	}
}

$time_end = microtime_float();
$time = $time_end - $time_start;

echo "<br /><br /><center>Conversion XForum -> pnForum executed in $time seconds</center>";
echo "<br />";
echo "<center>This script has been written by <a href=\"http://www.dev-postnuke.com\">dev-postnuke.com</a></center>";
exit();

function menu( $id ) {
	echo "<u>Conversion menu</u><br>";
	echo "<br />";
	echo "0. <a href=\"".$_SERVER['PHP_SELF']."?id=1\">Truncate pnForum tables (caution: this will destroy all existing data!)</a><br>";
	echo "1. <a href=\"".$_SERVER['PHP_SELF']."?id=2\">Convert categories</a><br>";
	if( $id >= 2 ) {
		echo "2. <a href=\"".$_SERVER['PHP_SELF']."?id=3\">Convert forums</a><br>";
	} else {
		echo "2. Convert forums<br>";
	}
	if( $id >= 3 ) {
		echo "3. <a href=\"".$_SERVER['PHP_SELF']."?id=4\">Convert topics</a><br>";
	} else {
		echo "3. Convert topics<br>";
	}
	if( $id >= 4 ) {
		echo "4. <a href=\"".$_SERVER['PHP_SELF']."?id=5\">Convert posts</a><br>";
	} else {
		echo "4. Convert posts<br>";
	}
	if( $id >= 5 ) {
		echo "5. <a href=\"".$_SERVER['PHP_SELF']."?id=6\">Convert moderators</a><br>";
	} else {
		echo "5. Convert moderators<br>";
	}
	if( $id >= 6 ) {
		echo "6. <a href=\"".$_SERVER['PHP_SELF']."?id=7\">Optimization and synchronization</a><br>";
	} else {
		echo "6. Optimization and synchronization<br>";
	}
	echo "<br>";
	echo "7. <a href=\"".$_SERVER['PHP_SELF']."?id=8\">Run complete conversion</a><br>";
	flush();

	return true;
}
function optimize()
{
	global $dbconn, $pntable;

	// posts table
    $pnforumpoststable = $pntable['pnforum_posts'];
    $pnforumpostscolumn = &$pntable['pnforum_posts_column'];
    $pnforumuserstable = $pntable['pnforum_users'];
    $pnforumuserscolumn = &$pntable['pnforum_users_column'];

	echo "OPTIMIZATION AND SYNCHRONIZATION<br>";
	flush();
	if(!pnModAPILoad('pnForum', 'admin')) {
        echo "loading adminapi failed";
		flush();
		return false;
    }

	pnModAPIFunc('pnForum', 'admin', 'sync', array( 'id' => NULL, 'type' => "all forums"));
	echo "Forums synchronized!<br>";
	flush();

	pnModAPIFunc('pnForum', 'admin', 'sync', array( 'id' => NULL, 'type' => "all topics"));
	echo "Topics synchronized!<br>";
	flush();

	pnModAPIFunc('pnForum', 'admin', 'sync', array( 'id' => NULL, 'type' => "all posts"));
	echo "Posts synchronized!<br>";
	flush();

	pnModAPIFunc('pnForum', 'admin', 'sync', array( 'id' => NULL, 'type' => "users"));
	echo "Users synchronized!<br>";
	flush();

	echo "counting user posts...<br />";
	$allusers = pnUserGetAll();
	foreach($allusers as $user) {
	    // count the users postings
	    $sql = "SELECT COUNT(*) FROM $pnforumpoststable WHERE $pnforumpostscolumn[poster_id] = " . pnVarPrepForStore($user['uid']);
        $result = $dbconn->Execute($sql);
        if ($dbconn->ErrorNo() != 0) {
        	die($dbconn->ErrorMsg() . " : $sql");
        }
        list($numposts) = $result->fields;
        $result->Close();

    	$sql2 = "UPDATE $pnforumuserstable SET $pnforumuserscolumn[user_posts]='$numposts' WHERE $pnforumuserscolumn[user_id]=" . $user['uid'];
        $result = $dbconn->Execute($sql2);
        if ($dbconn->ErrorNo() != 0) {
        	die($dbconn->ErrorMsg() . " : $sql2");
        }
        $result->Close();
	}

    return true;
}

/**
* Conversion de Moderadores
* Moderators Porting
*/
function convert_mods()
{
	global $dbconn, $pntable, $xf_table_forums;
   	echo "CONVERT MODERATORS FROM XFORUM --> PNFORUM .... <br>";
    flush();
    $pnforumforummodstable = $pntable['pnforum_forum_mods'];
    $pnforumforummodscolumn = &$pntable['pnforum_forum_mods_column'];
	// Usuarios
	$usrcolumn = &$pntable['users_column'];
	// Se vacia la tabla destino:
    $sql = "DELETE FROM $pnforumforummodstable";
    $result = $dbconn->Execute($sql);
    if ($dbconn->ErrorNo() != 0) {
    	die($dbconn->ErrorMsg() . " : $sql");
    }

	$sql = "SELECT $xf_table_forums.moderator, $xf_table_forums.fid, $xf_table_forums.name
			FROM $xf_table_forums
			WHERE $xf_table_forums.type='forum'
			ORDER BY $xf_table_forums.fid ASC";
	$result = $dbconn->Execute($sql);
    if ($dbconn->ErrorNo() != 0) {
    	die($dbconn->ErrorMsg() . " : $sql");
    }
	for (; !$result->EOF; $result->MoveNext()) {
        list($moderator,$fid,$name) = $result->fields;
		$moderadores = explode(',',$moderator);
		echo " * $fid : $name : ";
		flush();
		foreach( $moderadores as $mod ) {
			$mod = trim($mod);
			// UID de cada usuario
			$sql = "SELECT pn_uid FROM $pntable[users] WHERE pn_uname='".pnVarPrepForStore($mod)."'";
    		$resultMod =& $dbconn->Execute($sql);
    		if ($dbconn->ErrorNo() != 0) {
				echo " !! $mod !! ";
				flush();
				continue;
    		}

		    list($uid) = $resultMod->fields;
    		$resultMod->Close();

			// Se guardan los datos en pnForum
			$sql = "INSERT INTO $pnforumforummodstable (
						$pnforumforummodscolumn[forum_id],
						$pnforumforummodscolumn[user_id] )
					VALUES ('$fid', '$uid')";
			$resultMods = $dbconn->Execute($sql);
		    if ($dbconn->ErrorNo() != 0) {
    			die($dbconn->ErrorMsg() . " : $sql");
		    } else {
				echo " * ";
				flush();
			}
			$resultMods->Close();
		}
		echo " OK<br>";
		flush();
	}
	$result->Close();
	return true;
}

function convert_categories()
{
    global $dbconn, $pntable, $xf_table_forums;
    echo "CONVERT CATEGORIES FROM XFORUM --> PNFORUM .... ";
	flush();
	// Se vacia la tabla destino:
	$tocattable   = $pntable['pnforum_categories'];
    $tocatcolumn  = &$pntable['pnforum_categories_column'];
    $sql = "DELETE FROM $tocattable";
    $result = $dbconn->Execute($sql);
    if ($dbconn->ErrorNo() != 0) {
    	die($dbconn->ErrorMsg() . " : $sql");
    }
    // Se escribe en la tabla con los datos de XForum:
	$sql = "INSERT INTO $tocattable (
                $tocatcolumn[cat_id],
                $tocatcolumn[cat_title],
                $tocatcolumn[cat_order])
            SELECT " . $xf_table_forums . ".fid,
                   " . $xf_table_forums . ".name,
                   " . $xf_table_forums . ".displayorder
            FROM $xf_table_forums
			WHERE " . $xf_table_forums . ".type='group'";
    $result = $dbconn->Execute($sql);
    if ($dbconn->ErrorNo() != 0) {
    	die($dbconn->ErrorMsg() . " : $sql");
    }
    echo $dbconn->Affected_Rows() . " categories converted<br />";
    flush();

	return true;
}
function convert_forums()
{
    global $dbconn, $pntable, $xf_table_forums;
   	echo "CONVERT FORUMS FROM XFORUM --> PNFORUM .... ";
    flush();
    $fromforumstable = $xf_table_forums;
    $toforumstable   = $pntable['pnforum_forums'];
    $toforumscolumn  = &$pntable['pnforum_forums_column'];
	// Se vacia la tabla destino:
    $sql = "DELETE FROM $toforumstable";
    $result = $dbconn->Execute($sql);
    if ($dbconn->ErrorNo() != 0) {
    	die($dbconn->ErrorMsg() . " : $sql");
    }
	// Se escribe en la tabla con los datos de XForum:
    $sql = "INSERT INTO $toforumstable (
                $toforumscolumn[forum_id],
                $toforumscolumn[cat_id],
                $toforumscolumn[forum_name],
                $toforumscolumn[forum_desc],
                $toforumscolumn[forum_order],
                $toforumscolumn[forum_posts],
                $toforumscolumn[forum_topics])
            SELECT " . $fromforumstable . ".fid,
                   " . $fromforumstable . ".fup,
                   " . $fromforumstable . ".name,
                   " . $fromforumstable . ".description,
                   " . $fromforumstable . ".displayorder,
                   " . $fromforumstable . ".posts,
                   " . $fromforumstable . ".threads
            FROM $fromforumstable
			WHERE " . $fromforumstable . ".type='forum'";
    $result = $dbconn->Execute($sql);
    if ($dbconn->ErrorNo() != 0) {
    	die($dbconn->ErrorMsg() . " : $sql");
    }
    echo $dbconn->Affected_Rows() . " forums converted<br />";
    flush();
    return;
}

/**
 * Topics
 *
 */
function convert_topics()
{
    global $dbconn, $pntable, $xf_table_threads;
    echo "CONVERT TOPICS FROM XFORUM --> PNFORUM<br />";
    flush();
    $totopicstable   = $pntable['pnforum_topics'];
    $totopicscolumn  = &$pntable['pnforum_topics_column'];
	// Se vacia la tabla destino:
    $sql = "DELETE FROM $totopicstable";
    $result = $dbconn->Execute($sql);
    if ($dbconn->ErrorNo() != 0) {
    	die($dbconn->ErrorMsg() . " : $sql");
    }
	// creating posts table
    $pnforumpoststable = $pntable['pnforum_posts'];
    $pnforumpostscolumn = &$pntable['pnforum_posts_column'];

	$sql = "DELETE FROM $pnforumpoststable";
    $result = $dbconn->Execute($sql);
    if ($dbconn->ErrorNo() != 0) {
    	die($dbconn->ErrorMsg() . " : $sql");
    }
    // creating posts text table
    $pnforumpoststexttable = $pntable['pnforum_posts_text'];
    $pnforumpoststextcolumn = &$pntable['pnforum_posts_text_column'];
	$sql = "DELETE FROM $pnforumpoststexttable";
    $result = $dbconn->Execute($sql);
    if ($dbconn->ErrorNo() != 0) {
    	die($dbconn->ErrorMsg() . " : $sql");
    }
	// topic subscription table
    $pnforumtopicsubscriptiontable = $pntable['pnforum_topic_subscription'];
    $pnforumtopicsubscriptioncolumn = &$pntable['pnforum_topic_subscription_column'];
	/*
	* - Se leen todos los datos de cada Thread desde la Tabla $xf_table_threads de XForum
	* - Se transforman para adecuarlos a las tablas pnForum
	* - Se inserta los datos generales de cada Topic en la tabla Topics de pnForum
	* - Se insertan los datos del usuario, id en la tabla Posts de pnForum
	* - Se inserta el texto del Topic en la tabla PostText de pnForum
	*/
	$sql = "SELECT $pntable[users].pn_uid,
				   " . $xf_table_threads .".tid,
                   " . $xf_table_threads .".fid,
                   " . $xf_table_threads .".subject,
				   " . $xf_table_threads .".views,
                   " . $xf_table_threads .".replies,
                   " . $xf_table_threads .".author,
                   " . $xf_table_threads .".message,
				   " . $xf_table_threads .".dateline,
                   " . $xf_table_threads .".closed,
                   " . $xf_table_threads .".topped,
                   " . $xf_table_threads .".useip,
                   " . $xf_table_threads .".usesig,				   
                   " . $xf_table_threads .".emailnotify				   
            FROM (     $xf_table_threads INNER JOIN $pntable[users] ON $xf_table_threads.author = $pntable[users].pn_uname)
            ORDER BY   $xf_table_threads.tid";
	$result =& $dbconn->Execute($sql);
    if ($dbconn->ErrorNo() != 0) {
    	die($dbconn->ErrorMsg() . " : $sql");
    }
	echo $dbconn->Affected_Rows() . " topics read. Starting conversion<br />";
    flush();

	$topicCounter = 0;
	for (; !$result->EOF; $result->MoveNext()) {
        list($uid,$tid,$fid,$subject,$views,$replies,$author,$message,$dateline,$closed,$topped,$userip,$usesig,$emailnotify) = $result->fields;
		$closed == "yes" ? $status=1 : $status=0;

		$sql = "INSERT INTO $totopicstable (
					$totopicscolumn[topic_id],
	                $totopicscolumn[forum_id],
    	            $totopicscolumn[topic_title],
        	        $totopicscolumn[topic_poster],
            	    $totopicscolumn[topic_views],
                	$totopicscolumn[topic_replies],
	                $totopicscolumn[topic_status],
					$totopicscolumn[sticky],
					$totopicscolumn[topic_time] )
				VALUES ('$tid', '$fid', '$subject', '$uid', '$views', '$replies', '$status', '$topped','".date("Y-m-d H:i", $dateline)."')";
		$resultInsertInTopics =& $dbconn->Execute($sql);
    	if ($dbconn->ErrorNo() != 0) {
    		die($dbconn->ErrorMsg() . " : $sql");
	    } else {
			// Se guarda el Post
			$sql = "INSERT INTO $pnforumpoststable (
						$pnforumpostscolumn[topic_id],
						$pnforumpostscolumn[forum_id],
						$pnforumpostscolumn[poster_id],
						$pnforumpostscolumn[post_time],
						$pnforumpostscolumn[poster_ip])
					VALUES ('$tid','$fid','$uid','".date("Y-m-d H:i", $dateline)."','$userip')";
			$resultInsertInPostTable =& $dbconn->Execute($sql);
	    	if ($dbconn->ErrorNo() != 0) {
    			die($dbconn->ErrorMsg() . " : $sql");
	    	}
			$post_id = $dbconn->PO_Insert_ID($pnforumpoststable, $pnforumpostscolumn['post_id']);

			// take care about usesig setting
	        if($usesig=='yes') {
    	        $message .= "\n[addsig]";
        	}
	        // build topic subscription table
    	    if($emailnotify=='yes') {
        	    if(pnModAPIFunc('pnForum', 'user', 'get_topic_subscription_status', array('userid' => $uid, 'topic_id' => $tid)) == false) {
	                $sql3 = "INSERT INTO $pnforumtopicsubscriptiontable (
									$pnforumtopicsubscriptioncolumn[user_id], 
									$pnforumtopicsubscriptioncolumn[forum_id], 
									$pnforumtopicsubscriptioncolumn[topic_id] )
    	                    	VALUES ('".(int)pnVarPrepForStore($uid)."','".(int)pnVarPrepForStore($fid)."','".(int)pnVarPrepForStore($tid)."')";
	                $result3 = $dbconn->Execute($sql3);
    	            if ($dbconn->ErrorNo() != 0) {
        	        	die($dbconn->ErrorMsg() . " : $sql3");
            	    }
                	$result3->Close();
	            }
    	    }
		
			// Se guarda el TEXTO del Post
			$sql = "INSERT INTO $pnforumpoststexttable (
						$pnforumpoststextcolumn[post_id],
						$pnforumpoststextcolumn[post_text])
					VALUES ('$post_id', '$message')";
			$resultInsertInPostTextTable =& $dbconn->Execute($sql);
	    	if ($dbconn->ErrorNo() != 0) {
    			die($dbconn->ErrorMsg() . " : $sql");
	    	}

			$topicCounter++;

			if( $topicCounter%10 == 0 ) {
				echo "."; flush();
			}
			if( $topicCounter%100 == 0 ) {
				echo " $topicCounter "; flush();
			}
			if( $topicCounter%1000 == 0 ) {
				echo "<br />"; flush();
			}
		}
	}
	$result->Close();
	echo "<br>$topicCounter topics converted<br><br>";

/* not used here ??

	$sql = "UPDATE $pnforumpoststable SET $pnforumpostscolumn[topic_poster]=1 WHERE $pnforumpostscolumn[topic_poster]=0";
    $result = $dbconn->Execute($sql);
    if ($dbconn->ErrorNo() != 0) {
    	die($dbconn->ErrorMsg() . " : $sql");
    }
    echo "Anonymous User changed to userid 1 in " . $dbconn->Affected_Rows() . " topics<br />";
*/
    flush();

    return;
}
function convert_posts()
{
	global $dbconn, $pntable, $xf_table_posts;
    echo "CONVERT POSTS FROM XFORUM --> PNFORUM<br />";
    flush();

	// posts table
    $pnforumpoststable = $pntable['pnforum_posts'];
    $pnforumpostscolumn = &$pntable['pnforum_posts_column'];
    // posts text table
    $pnforumpoststexttable = $pntable['pnforum_posts_text'];
    $pnforumpoststextcolumn = &$pntable['pnforum_posts_text_column'];
    // topic subscription table
    $pnforumtopicsubscriptiontable = $pntable['pnforum_topic_subscription'];
    $pnforumtopicsubscriptioncolumn = &$pntable['pnforum_topic_subscription_column'];

	$sql = "SELECT $pntable[users].pn_uid,
				   " . $xf_table_posts .".tid,
                   " . $xf_table_posts .".fid,
				   " . $xf_table_posts .".author,
				   " . $xf_table_posts .".message,
				   " . $xf_table_posts .".dateline,
                   " . $xf_table_posts .".usesig,
				   " . $xf_table_posts .".useip,
				   " . $xf_table_posts .".emailnotify
            FROM (     $xf_table_posts INNER JOIN $pntable[users] ON $xf_table_posts.author = $pntable[users].pn_uname)
            ORDER BY   $xf_table_posts.pid";
	$result =& $dbconn->Execute($sql);
    if ($dbconn->ErrorNo() != 0) {
    	die($dbconn->ErrorMsg() . " : $sql");
    }
	echo $dbconn->Affected_Rows() . " posts read. Starting conversion<br />";
    flush();

	$postCounter = 0;
	for (; !$result->EOF; $result->MoveNext()) {
        list($uid,$tid,$fid,$author,$message,$dateline,$usesig,$userip,$emailnotify) = $result->fields;

		// Se guarda el Post
		$sql = "INSERT INTO $pnforumpoststable (
					$pnforumpostscolumn[topic_id],
					$pnforumpostscolumn[forum_id],
					$pnforumpostscolumn[poster_id],
					$pnforumpostscolumn[post_time],
					$pnforumpostscolumn[poster_ip])
				VALUES ('$tid','$fid','$uid','".date("Y-m-d H:i", $dateline)."','$userip')";
		$resultInsertInPostTable =& $dbconn->Execute($sql);
	    if ($dbconn->ErrorNo() != 0) {
    		die($dbconn->ErrorMsg() . " : $sql");
	    }
		$post_id = $dbconn->PO_Insert_ID($pnforumpoststable, $pnforumpostscolumn['post_id']);

        // take care about usesig setting
        if($usesig=='yes') {
            $message .= "\n[addsig]";
        }
        // build topic subscription table
        if($emailnotify=='yes') {
            if(pnModAPIFunc('pnForum', 'user', 'get_topic_subscription_status',
                            array('userid' => $uid,
                                  'topic_id' => $tid)) == false) {
                $sql3 = "INSERT INTO $pnforumtopicsubscriptiontable (user_id, forum_id, topic_id)
                        VALUES ('".(int)pnVarPrepForStore($uid)."','".(int)pnVarPrepForStore($fid)."','".(int)pnVarPrepForStore($tid)."')";
                $result3 = $dbconn->Execute($sql3);
                if ($dbconn->ErrorNo() != 0) {
                	die($dbconn->ErrorMsg() . " : $sql3");
                }
                $result3->Close();
            }
        }

		// Se guarda el TEXTO del Post
		$sql = "INSERT INTO $pnforumpoststexttable (
					$pnforumpoststextcolumn[post_id],
					$pnforumpoststextcolumn[post_text])
				VALUES ('$post_id', '$message')";
		$resultInsertInPostTextTable =& $dbconn->Execute($sql);
    	if ($dbconn->ErrorNo() != 0) {
   			die($dbconn->ErrorMsg() . " : $sql");
    	}
		$postCounter++;

		if( $postCounter%10 == 0 ) {
			echo "."; flush();
		}
		if( $postCounter%100 == 0 ) {
			echo " $postCounter "; flush();
		}
		if( $postCounter%1000 == 0 ) {
			echo "<br />"; flush();
		}
	}

	$sql2 = "UPDATE $pnforumpoststable SET $pnforumpostscolumn[poster_id]=1 WHERE $pnforumpostscolumn[poster_id]=0";
    $result2 = $dbconn->Execute($sql2);
    if ($dbconn->ErrorNo() != 0) {
    	die($dbconn->ErrorMsg() . " : $sql2");
    }
    echo "Anonymous User changed to userid 1 in " . $dbconn->Affected_Rows() . " postings<br />";
    flush();
	return;
}

function truncate_destination_tables()
{
    global $dbconn, $pntable, $prefix;
	$sql = array();
	$sql[$pntable['pnforum_categories']] 		= "TRUNCATE $pntable[pnforum_categories]";
	$sql[$pntable['pnforum_forum_mods']] 		= "TRUNCATE $pntable[pnforum_forum_mods]";
	$sql[$pntable['pnforum_forums']] 			= "TRUNCATE $pntable[pnforum_forums]";
	$sql[$pntable['pnforum_posts']] 			= "TRUNCATE $pntable[pnforum_posts]";
	$sql[$pntable['pnforum_posts_text']] 		= "TRUNCATE $pntable[pnforum_posts_text]";
	$sql[$pntable['pnforum_subscription']] 		= "TRUNCATE $pntable[pnforum_subscription]";
	$sql[$pntable['pnforum_ranks']] 			= "TRUNCATE $pntable[pnforum_ranks]";
	$sql[$pntable['pnforum_topics']] 			= "TRUNCATE $pntable[pnforum_topics]";
	$sql[$pntable['pnforum_users']] 			= "TRUNCATE $pntable[pnforum_users]";
	$sql[$pntable['pnforum_topic_subscription']]= "TRUNCATE $pntable[pnforum_topic_subscription]";
	$sql[$pntable['pnforum_forum_favorites']] 	= "TRUNCATE $pntable[pnforum_forum_favorites]";

	echo "TRUNCATING ALL TABLES IN PNFORUM<br />";
	foreach( $sql as $key => $val ) {
		echo "* truncating table: $key .... ";
		$result = $dbconn->Execute($val);
	    if ($dbconn->ErrorNo() != 0) {
    		die($dbconn->ErrorMsg() . " : $val");
			//echo $dbconn->ErrorMsg() . " : $val<br>";
	    } else {
			echo "OK<br />";
		}
	}
	echo "<br />";
	flush();
	return;
}

function microtime_float()
{
    list($usec, $sec) = explode(" ", microtime());
    return ((float)$usec + (float)$sec);
}
?>